#include <windows.h>
#include "oh_othmn.h"
#include "oh_debug.h"

extern oh_int oh_io_init(oh_void);
extern BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason,
  PVOID fImpLoad);

static DWORD WINAPI OthMainThread(LPVOID lpParameter);

static DWORD WINAPI OthMainThread(LPVOID lpParameter)
{
#ifdef OH_DEBUG
  oh_io_init();
#endif /* OH_DEBUG */
  oh_db_log((OL_MSG, OD_DEF, "DllMain start"));
  OthMain((HINSTANCE)lpParameter);
  OH_ASSERT(FALSE);
  ExitProcess(0);

  return 0;
}

BOOL WINAPI DllMain(HINSTANCE hinstDll, DWORD fdwReason, PVOID fImpLoad)
{
  DWORD tid;

  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:
      /* create a new thread to prevent the DllMain deadlock */
      CreateThread(0, 0, OthMainThread, (LPVOID)hinstDll, 0, &tid);
      break;

    case DLL_THREAD_ATTACH:
      break;

    case DLL_THREAD_DETACH:
      break;

    case DLL_PROCESS_DETACH:
      break;
   }
   return TRUE;
}

