include $(OH_BUILDROOT)/setting.mk

include $(OH_BUILDROOT)/arch/$(OH_CPUOS)/compiler/$(OH_COMPILER)/etc/env.mk
include $(OH_BUILDROOT)/prj/$(OH_PROJECT)/share/etc/env.mk

OH_OBJDIR=$(OH_BUILDROOT)/build/$(OH_PROJECT)/obj/$(OH_PACKAGE)
OH_LIBDIR=$(OH_BUILDROOT)/build/$(OH_PROJECT)/lib
OH_BINDIR=$(OH_BUILDROOT)/build/$(OH_PROJECT)/bin
OH_SRCDIR=./src
OH_SRCINCDIR=./src/inc
OH_ETCDIR=./etc
OH_SRCS=$(wildcard $(addprefix $(OH_SRCDIR)/,$(OH_SRCEXTS)))
OH_OBJNAMES=$(sort $(addsuffix $(OH_OBJEXT),$(basename $(notdir $(OH_SRCS)))))
OH_OBJS=$(addprefix $(OH_OBJDIR)/,$(OH_OBJNAMES))

ifeq ($(OH_DEBUG),TRUE)
OH_DEFINES+=OH_DEBUG
endif

ifeq ($(OH_TESTKIT),TRUE)
OH_DEFINES+=OH_TESTKIT
endif

OH_DEFINES+=OH_PROJECT=$(OH_PROJECT)
OH_INCDIRS+=$(OH_SRCINCDIR)
