#ifndef _OH_TSTCS_H_
#define _OH_TSTCS_H_

#include "oh_port.h"

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

typedef struct oh_tk_opt_t
{
  const oh_char *homedir;
  const oh_char *testdir;
  const oh_ulong filelen;
  const oh_ulong bufflen;
} oh_tk_opt_t;

typedef struct oh_tk_tc_t
{
  const oh_char *explain;
  const oh_char *tcfuncname;
  oh_int (*tcfunc)(oh_tk_opt_t *opt);
} oh_tk_tc_t;

extern oh_int oh_tk_testCompiler(oh_tk_opt_t *opt);
extern oh_int oh_tk_testCLib(oh_tk_opt_t *opt);
extern oh_int oh_tk_testFS(oh_tk_opt_t *opt);
extern oh_int oh_tk_testArgs(oh_tk_opt_t *opt);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _OH_TSTCS_H_ */
